package tui

type Events interface {

	// OnKeyPressed is called every time a key or key-combination is pressed.
	// If OnKeyPressed returns true, the event will not be passed onto child views
	OnKeyPressed(event *KeyEvent) (consumed bool)

	// OnMouseClicked is called every time a mouse button was pressed on the view.
	// If OnMouseClicked returns true, the event will not be passed onto child views
	OnMouseClicked(event *MouseEvent) (consumed bool)
}
